# from django.core.files.storage import Storage
# import b2sdk.v2 as b2
# from django.conf import settings
# import os
# import re
# import requests
# from io import BytesIO

# class BackblazeStorage(Storage):
#     def __init__(self, *args, **kwargs):
#         super().__init__(*args, **kwargs)
#         self.b2_api = self._authorize()

#     def _authorize(self):
#         # Initializes and authorizes B2 API with account info
#         info = b2.InMemoryAccountInfo()
#         b2_api = b2.B2Api(info)
#         b2_api.authorize_account("production", settings.B2_ACCOUNT_ID, settings.B2_APPLICATION_KEY)
#         return b2_api

#     def _get_bucket(self):
#         # Retrieves bucket by name; raises an error if the bucket is not found
#         try:
#             return self.b2_api.get_bucket_by_name(settings.B2_BUCKET_NAME)
#         except b2.exception.BucketNotFound:
#             raise ValueError("Bucket not found. Check your bucket name and account settings.")

#     def _open(self, name, mode='rb'):
#         # Downloads file content from Backblaze as a file-like object
#         bucket = self._get_bucket()
#         try:
#             file_info = bucket.get_file_info_by_name(name)
#             download_url = file_info.download_url
#             response = requests.get(download_url)
#             response.raise_for_status()
#             return BytesIO(response.content)  # Return as a file-like object
#         except requests.RequestException as e:
#             raise IOError(f"Failed to open file: {e}")

#     def _save(self, name, content):
#         # Saves a file to Backblaze bucket
#         bucket = self._get_bucket()
#         file_bytes = content.read()
#         try:
#             bucket.upload_bytes(file_bytes, name)
#             return name
#         except b2.exception.B2Error as e:
#             raise IOError(f"Failed to save file: {e}")

#     def exists(self, name):
#         # Checks if a file exists in the bucket
#         bucket = self._get_bucket()
#         try:
#             bucket.get_file_info_by_name(name)
#             return True
#         except b2.exception.FileNotPresent:
#             return False

#     def url(self, name):
#         # Constructs a public URL for the file
#         return f"https://{settings.END_POINT_URL}/file/{settings.B2_BUCKET_NAME}/{name}"

#     def delete(self, name):
#         # Deletes a file from the bucket
#         bucket = self._get_bucket()
#         try:
#             file_info = bucket.get_file_info_by_name(name)
#             bucket.delete_file_version(file_info.file_name, file_info.file_id)
#         except b2.exception.FileNotPresent:
#             pass  # File doesn't exist, so nothing to delete

#     def size(self, name):
#         # Retrieves the size of a file in bytes
#         bucket = self._get_bucket()
#         try:
#             file_info = bucket.get_file_info_by_name(name)
#             return file_info.size
#         except b2.exception.FileNotPresent:
#             return None

# def sanitize_filename(filename):
#     # Sanitizes filename by removing invalid characters
#     base_name = os.path.basename(filename)
#     sanitized_name = re.sub(r'[\\/:*?"<>|]', '', base_name)
#     return sanitized_name

# def upload_to_backblaze(file):
#     # Directly uploads a file to Backblaze bucket with sanitized filename
#     info = b2.InMemoryAccountInfo()
#     b2_api = b2.B2Api(info)
#     b2_api.authorize_account("production", settings.B2_ACCOUNT_ID, settings.B2_APPLICATION_KEY)

#     bucket = b2_api.get_bucket_by_name(settings.B2_BUCKET_NAME)

#     file_name = sanitize_filename(file.name)
#     folder_name = "onboarding-images"
#     file_path = f"{folder_name}/{file_name}"

#     file_bytes = file.read()
#     try:
#         bucket.upload_bytes(file_bytes, file_path)
#         file_url = f"https://{settings.END_POINT_URL}/file/{settings.B2_BUCKET_NAME}/{file_path}"
#         return file_url
#     except b2.exception.B2Error as e:
#         raise IOError(f"Failed to upload file to Backblaze: {e}")
